---
title: "Switching to Axum"
date: 2022-04-02
tags:
    - rust
---

In classic Jef fashion, it took me less than a week to completely overhaul the
way my site works ;p Visually nothing's changed, but internally the website is
now being powered by a web server [written in
Rust](https://git.rustybever.be/Chewing_Bever/site-backend), powered by
[Axum](https://github.com/tokio-rs/axum).

The reason for this is expandibility. While nginx is really good at what it
does, it's rather limited when it comes to implementing new features on top of
it. However, even if it wasn't, I would've still switched because I just really
wanted to work in Rust once more :D

Favoritism aside, the plan is to join the [IndieWeb](https://indieweb.org/)
network. To quote their homepage:

> The IndieWeb is a people-focused alternative to the "corporate web".

They've got some really great ideas about what the internet could be if we
tried, and considering I agree with nearly all of them, I wanna join ;p

My first project will be to implement the Webmention protocol. This consists of
a simple exchange of POST requests, where you notify another user's site
whenever you mention one of their posts. This in exchange allows them to
display my response on their website, and vice versa! In essence, it's simple
decentralized commenting.

My plans after this are still vague. I might dip my toes into
[IndieAuth](https://indieauth.net/),
[microformats](https://indieweb.org/microformats) or any of the other cool
concepts they've got the offer! Either way, the plan is to enjoy myself with
this site ;p

If all goes well, this post will be the first new post to get published using
my new deploy system, so fingers crossed :)

Have a lovely day <3
